package persistent.counter.client;

import java.io.FileInputStream;
import java.util.Calendar;
import javax.xml.rpc.Stub;

import org.apache.axis.message.addressing.EndpointReferenceType;

import org.globus.axis.util.Util;
import org.globus.wsrf.encoding.ObjectDeserializer;

import org.oasis.wsrf.lifetime.SetTerminationTime;

import org.xml.sax.InputSource;

import persistent.counter.Counter;
import persistent.counter.service.CounterServiceAddressingLocator;

public class CounterSetTerminationTime {
    static {
        Util.registerTransport();
    }    

    public static void main(String[] args) throws Exception {
        CounterServiceAddressingLocator locator =
            new CounterServiceAddressingLocator();
        
	try {
            String eprFile = args[0];
            int remainingLifetime = Integer.parseInt(args[1]);

            // Get endpoint reference of WS-Resource from file
            FileInputStream fis = new FileInputStream(eprFile);
            EndpointReferenceType endpoint = (EndpointReferenceType)
                ObjectDeserializer.deserialize(
                    new InputSource(fis), EndpointReferenceType.class
                );
            fis.close();

            // Get counter WS-Resource
            Counter counter = locator.getCounterPort(endpoint);

            // Configure security
            SecurityHelper.setSecurity((Stub) counter);            

            // Set counter termination time
            Calendar terminationTime = Calendar.getInstance();
            terminationTime.add(Calendar.SECOND, remainingLifetime);
            counter.setTerminationTime(
                new SetTerminationTime(terminationTime)
            );
	} catch (ArrayIndexOutOfBoundsException e) {
            System.err.println("Usage: CounterSetTerminationTime <EPR file> seconds ");
	}	    
    }
}
